#include <bits/stdc++.h>
#define ll long long

using namespace std;

int n,m,k;
bool mark[2000][2000];
int sol;

bool moze(int x, int y)
{
    return !mark[x][y] && x>=0 && x<n && y>=0 && y<m;
}

void dfs(int x, int y)
{
    //cout<<x<<" "<<y<<" "<<sol<<endl;
    mark[x][y]=true;
    for(int i=-1;i<=1;i+=2)
    {
        if(moze(x+i,y))
            dfs(x+i,y);
        if(moze(x,y+i))
            dfs(x,y+i);
    }
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin>>n>>m>>k;
	int x,y;
	for(int i=0;i<k;i++)
    {
        cin>>x>>y;
        x--;
        y--;
        mark[x][y]=true;
    }
    sol=0;
    for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
        {
            if(!mark[i][j])
            {
                sol++;
                dfs(i,j);
            }
        }
    cout<<sol;

	return 0;
}